# coding: utf-8

"""
Crypticorn Auth API

OpenAPI compliant REST API built using tRPC with Express

The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Union
from crypticorn.auth.client.models.list_wallets200_response_balances_inner_sale_round import (
    ListWallets200ResponseBalancesInnerSaleRound,
)
from crypticorn.auth.client.models.list_wallets200_response_balances_inner_wallet import (
    ListWallets200ResponseBalancesInnerWallet,
)
from typing import Optional, Set
from typing_extensions import Self


class ListWallets200ResponseBalancesInner(BaseModel):
    """
    ListWallets200ResponseBalancesInner
    """  # noqa: E501

    wallet: ListWallets200ResponseBalancesInnerWallet
    sale_round: ListWallets200ResponseBalancesInnerSaleRound = Field(alias="saleRound")
    value_usd: Union[StrictFloat, StrictInt] = Field(alias="valueUsd")
    value_aic: Union[StrictFloat, StrictInt] = Field(alias="valueAic")
    __properties: ClassVar[List[str]] = ["wallet", "saleRound", "valueUsd", "valueAic"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListWallets200ResponseBalancesInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of wallet
        if self.wallet:
            _dict["wallet"] = self.wallet.to_dict()
        # override the default output from pydantic by calling `to_dict()` of sale_round
        if self.sale_round:
            _dict["saleRound"] = self.sale_round.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListWallets200ResponseBalancesInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "wallet": (
                    ListWallets200ResponseBalancesInnerWallet.from_dict(obj["wallet"])
                    if obj.get("wallet") is not None
                    else None
                ),
                "saleRound": (
                    ListWallets200ResponseBalancesInnerSaleRound.from_dict(
                        obj["saleRound"]
                    )
                    if obj.get("saleRound") is not None
                    else None
                ),
                "valueUsd": obj.get("valueUsd"),
                "valueAic": obj.get("valueAic"),
            }
        )
        return _obj
