# coding: utf-8

"""
Crypticorn Auth API

OpenAPI compliant REST API built using tRPC with Express

The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self


class RefreshTokenInfo200ResponseUserSession(BaseModel):
    """
    RefreshTokenInfo200ResponseUserSession
    """  # noqa: E501

    id: StrictStr = Field(description="ID of the user session")
    user_id: StrictStr = Field(description="User ID of the user session")
    token: StrictStr = Field(description="Token of the user session")
    expires_at: datetime = Field(description="Expiration time of the user session")
    client_ip: Optional[StrictStr] = Field(
        default=None, description="Client IP address of the user session"
    )
    user_agent: Optional[StrictStr] = Field(
        default=None, description="User agent of the user session"
    )
    __properties: ClassVar[List[str]] = [
        "id",
        "user_id",
        "token",
        "expires_at",
        "client_ip",
        "user_agent",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RefreshTokenInfo200ResponseUserSession from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RefreshTokenInfo200ResponseUserSession from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "id": obj.get("id"),
                "user_id": obj.get("user_id"),
                "token": obj.get("token"),
                "expires_at": obj.get("expires_at"),
                "client_ip": obj.get("client_ip"),
                "user_agent": obj.get("user_agent"),
            }
        )
        return _obj
